/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 186 by dpavlin, Tue Mar 16 20:53:59 2010 UTC revision 301 by dpavlin, Tue Apr 9 19:49:31 2013 UTC
# Line 16  Line 16 
16  #  #
17  # based on Tony Risinger post to lxc-users mailing list  # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 33  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47  }  }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54    }
55    
56  lxc_status() {  lxc_status() {
57          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | while read name ; do
58                  on_boot="       "                  status=`lxc-info -n $name 2>/dev/null | grep state: | cut -d: -f2`     # 0.7.5
59                  test -s /var/lib/lxc/$name/on_boot && on_boot="on_boot"                  test -z "$status" && status=`lxc-info -n $name | sed -e 's/^.* is //'` # 0.7.2
60                  echo "$name $status $on_boot $(lxc_rootfs $name)"                  boot="-"
61          done                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
62                    echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
63            done ) | column -t
64  }  }
65    
66    
# Line 50  cleanup_init_scripts() { Line 68  cleanup_init_scripts() {
68          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
69    
70          ls \          ls \
71                    $rootfs/etc/rc?.d/*checkroot* \
72                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
73                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
74                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
75                    $rootfs/etc/rc?.d/*udev* \
76                    $rootfs/etc/rc?.d/*checkfs* \
77          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
78    
79            echo $1 > $rootfs/etc/hostname
80            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
81  }  }
82    
83    
# Line 64  setup_inittab() { Line 88  setup_inittab() {
88    
89          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
90          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
91          if ! grep "$add" ${inittab} >/dev/null ; then          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
92                  grep -v "$remove" ${inittab} > ${inittab}.new                  grep -v "$remove" ${inittab} > ${inittab}.new
93                  echo $add >> ${inittab}.new                  echo $add >> ${inittab}.new
94                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
# Line 73  setup_inittab() { Line 97  setup_inittab() {
97  }  }
98    
99    
100    lxc_log() {
101            echo `date +%Y-%m-%dT%H:%M:%S` $*
102    }
103    
104    
105  lxc_kill() {  lxc_kill() {
106          name=$1          name=$1
107          sig=$2          sig=$2
108    
109          init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`          ver=`lxc-version | cut -d: -f2 | sed 's/\.//g'`
110            opts=''
111            test $ver -ge 075 && opts='--'
112    
113            init_pid=`lxc-ps $opts -C init -o pid | grep "^$name" | cut -d" " -f2-`
114          if [ -z "$init_pid" ] ; then          if [ -z "$init_pid" ] ; then
115                  lxc-info -n $name                  lxc-info -n $name
116                  exit 1                  exit 1
117          fi          fi
118          echo "$name kill $sig $init_pid"          lxc_log "$name kill $sig $init_pid"
119          /bin/kill $sig $init_pid          /bin/kill $sig $init_pid
120  }  }
121    
122  lxc_stop() {  lxc_stop() {
123            lxc_log "$name stop"
124          lxc_kill $name -SIGPWR          lxc_kill $name -SIGPWR
125          lxc-wait -n $name -s STOPPED          lxc-wait -n $name -s STOPPED
126            lxc_log "$name stoped"
127  #       rm -f /var/lib/lxc/${name}/on_boot  #       rm -f /var/lib/lxc/${name}/on_boot
128  }  }
129    
130    
131  lxc_start() {  lxc_start() {
132          name=$1          name=$1
133            rootfs=$(lxc_rootfs $1)
134    
135            if [ ! -e $rootfs ] ; then
136                    echo "ERROR $name rootfs $rootfs not found"
137                    return
138            fi
139    
140          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
141                  echo "$name start"                  lxc_log "$name start"
142                    dev=`df -P $rootfs | tail -1 | cut -d" " -f1`
143                    mount $dev -o remount,rw # fix debian upgrade which remounts dir ro
144                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
145                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
146                  lxc-info  -n $name                  lxc-info  -n $name
# Line 107  lxc_start() { Line 150  lxc_start() {
150    
151  lxc_watchdog() {  lxc_watchdog() {
152  name=$1  name=$1
153    cgroup=$(mount -t cgroup | awk '{ print $3 }')
154    test -d "$cgroup/lxc/$1" && cgroup="$cgroup/lxc"
155  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
156    run=$rootfs/var/run
157    test -L $run && run=$rootfs/`readlink $run` # recent Debian have symlink to /run
158    cd $run || echo "can't cd watchdog into $run"
159    
160  while true; do  while true; do
161          vps_utmp=${rootfs}/var/run/utmp          tasks=`wc -l < $cgroup/${name}/tasks`
162          tasks=`wc -l < /cgroup/${name}/tasks`          stop_on=1 # init
163            sulogins=`lxc-ps --name $name | grep sulogin | wc -l`
164            if [ "$sulogins" -gt 0 ] ; then
165                    stop_on=`expr $stop_on + $sulogins`
166            fi
167    
168          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
169          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq $stop_on ]; then
170    
171                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel utmp)"
172                  echo `date +%Y-%m-%dT%H:%M:%S` "$name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
173    
174                  case $runlevel in                  case $runlevel in
175                  N*)                  N*)
176                          # nothing for new boot state                          # nothing for new boot state
177                  ;;                  ;;
178                  ??0)                  ??0|unknown)
179                          echo "$name halt"                          lxc_log "$name halt"
180                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
181                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
182                          break                          break
183                  ;;                  ;;
184                  ??6)                  ??6)
185                          echo "$name reboot";                          lxc_log "$name reboot";
186                          lxc-stop -n ${name}                          lxc-stop -n ${name}
187                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
188                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
# Line 141  while true; do Line 194  while true; do
194                  ;;                  ;;
195                  esac                  esac
196          else          else
197                  echo "# $name $tasks tasks"                  lxc_log "$name $tasks tasks $sulogins console"
198          fi          fi
199    
200          # time of 5 minutes on it JUST IN CASE...          # time of 5 minutes on it JUST IN CASE...
201          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 utmp
202  done  done
203    
204  echo "${name} exited"  lxc_log "$name watchdog exited"
205    
206  }  }
207    
208    
209    usage() {
210            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
211            exit 3
212    }
213    
214  command_on_lxc() {  command_on_lxc() {
215  command=$1  command=$1
216  shift  shift
# Line 164  case "$command" in Line 222  case "$command" in
222  start)  start)
223          lxc_exists $1          lxc_exists $1
224          cleanup_init_scripts $1          cleanup_init_scripts $1
225          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
226          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
227            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
228          lxc_start $1          lxc_start $1
229          # give container 5 seconds to start more than one process          # give container 5 seconds to start more than one process
230          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
# Line 180  reload|force-reload|restart|reboot) Line 239  reload|force-reload|restart|reboot)
239  watchdog)  watchdog)
240          lxc_watchdog $1          lxc_watchdog $1
241          ;;          ;;
242    boot)
243            echo $1 > /var/lib/lxc/$1/on_boot
244            ;;
245    disable)
246            echo -n > /var/lib/lxc/$1/on_boot
247            ;;
248  *)  *)
249          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
250          ;;          ;;
251    
252  esac  esac
# Line 190  esac Line 254  esac
254  }  }
255    
256  command=$1  command=$1
257  shift  test -z "$command" && usage
   
258  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
259    shift
260    
261  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
262          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do
263                  name=`echo $path | cut -d/ -f5`                  name=`echo $path | cut -d/ -f5`
264                  command_on_lxc $command $name                  if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
265                            command_on_lxc $command $name
266                    else
267                            echo "# skip $command $name"
268                    fi
269          done          done
270  else  else
271          while [ ! -z "$1" ] ; do          while [ ! -z "$1" ] ; do

Legend:
Removed from v.186  
changed lines
  Added in v.301

  ViewVC Help
Powered by ViewVC 1.1.26